module Graph
  module GossipConnection
    def initialize(graph_perspective, node)
      @graph_perspective = graph_perspective
      @node = node
    end
    
    def post_init
      local_node = @graph_perspective.local_node
      message = ([local_node.identity] + local_node.neighbors.values).join(",")
      send_data([message.size].pack("N") + message)
      @node.last_update = Time.now
    end
    
    def unbind
      if !@successful
        @graph_perspective.remove_edge(@graph_perspective.local_node, @node)
      end
    end
    
    def receive_data(data)
      @buffer ||= ""
      @buffer << data
      if @buffer == "ok"
        @graph_perspective.add_edge(@graph_perspective.local_node, @node)
        @successful = true
        close_connection
      end
    end
  end
end