module Graph
  module GossipHandler
    def initialize(graph_perspective)
      @graph_perspective = graph_perspective
    end
    
    def receive_data(data)
      @buffer ||= ""
      @buffer << data
      if @size || @buffer.size >= 4
        if @size.nil?
          @size, @buffer = @buffer[0, 4].unpack("N").first, @buffer[4..-1]
        end
        
        if @buffer.size >= @size
          data, remainder = @buffer[0, @size], @buffer[@size..-1]
          @size = nil
          ident, *list = data.split(",")
          node = Node[ident]
          EM.defer do
            @graph_perspective.update_with(node, list)
          end
          send_data("ok")
          receive_data(remainder)
        end
      end
    end
  end
end