module Graph
  class Gossiper
    def initialize(graph_perspective)
      @graph_perspective = graph_perspective
      local = @graph_perspective.local_node
      @thread = Thread.new do
        EM.run do
          EM.start_server(local.host, local.port, GossipHandler, @graph_perspective)
          EM.add_periodic_timer(1) {
            node = @graph_perspective.pick
            # puts
            if node
              # puts "Gossiping to #{node}"
              send_list(node)
            end
            
            graph_perspective.dump
          }
        end
      end
    end
    
    def send_list(node)
      EM.connect(node.host, node.port, GossipConnection, @graph_perspective, node)
    end
    
    def join
      @thread.join
    end
  end
end