package graph.Gossip

import java.util.{List,ArrayList}

import graph.Node

object NodeHelper {
  implicit def thrift2node(thriftObj:thrift.Node):Node = {
    val ident = thriftObj.getHost + ":" + thriftObj.getPort.toString
    Node(ident)
  }
  
  implicit def node2thrift(node:Node):thrift.Node = {
    new thrift.Node(node.host, node.port.toShort)
  }
  
  implicit def map2list(map:Map[String,Node]):List[thrift.Node] = {
    map.values.foldLeft(new ArrayList[thrift.Node]) { (list, node) => list.add(node); list }
  }
  
  implicit def list2list(list:List[thrift.Node]):scala.List[Node] = {
    var scalaList = scala.List[Node]()
    val iter = list.iterator
    while (iter.hasNext) scalaList = iter.next :: scalaList
    scalaList
  }
}