package graph

import javax.servlet.http.HttpServletRequest
import javax.servlet.http.HttpServletResponse
import javax.servlet.ServletException
 
import java.io.IOException
 
import org.eclipse.jetty.server.Request
import org.eclipse.jetty.websocket._
import org.eclipse.jetty.util.ajax.JSON


class GraphWebSocket(graphPerspective:GraphPerspective) extends WebSocketHandler {
  override def handle(target:String, baseRequest:Request, request:HttpServletRequest, response:HttpServletResponse) {
    if (target == "/update") {
      super.handle(target, baseRequest, request, response)
      baseRequest.setHandled(true)  
    }
  }
  
  override def doWebSocketConnect(request:HttpServletRequest, protocol:String):WebSocket = {
    new ClientWebSocket()
  }
  
  class ClientWebSocket extends WebSocket {
    var outbound:WebSocket.Outbound = _
    
    def onConnect(outbound:WebSocket.Outbound) {
      this.outbound = outbound
      println("on connection")
    }
    
    def onDisconnect {
      println("disconnect")
    }
    
    def onMessage(frame:Byte, data:Array[Byte], offset:Int, length:Int) {
    }
    
    def onMessage(frame:Byte, data:String) {
      outbound.sendMessage(new JSON().toJSON(graphPerspective))
    }
    
  }

}