/**
 * Autogenerated by Thrift
 *
 * DO NOT EDIT UNLESS YOU ARE SURE THAT YOU KNOW WHAT YOU ARE DOING
 */
package graph.Gossip.thrift;

import java.util.List;
import java.util.ArrayList;
import java.util.Map;
import java.util.HashMap;
import java.util.EnumMap;
import java.util.Set;
import java.util.HashSet;
import java.util.EnumSet;
import java.util.Collections;
import java.util.BitSet;
import java.util.Arrays;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import org.apache.thrift.*;
import org.apache.thrift.async.*;
import org.apache.thrift.meta_data.*;
import org.apache.thrift.transport.*;
import org.apache.thrift.protocol.*;

public class Graph {

  public interface Iface {

    public boolean gossip(Node sender, List<Node> neighbors) throws TException;

  }

  public interface AsyncIface {

    public void gossip(Node sender, List<Node> neighbors, AsyncMethodCallback<AsyncClient.gossip_call> resultHandler) throws TException;

  }

  public static class Client implements TServiceClient, Iface {
    public static class Factory implements TServiceClientFactory<Client> {
      public Factory() {}
      public Client getClient(TProtocol prot) {
        return new Client(prot);
      }
      public Client getClient(TProtocol iprot, TProtocol oprot) {
        return new Client(iprot, oprot);
      }
    }

    public Client(TProtocol prot)
    {
      this(prot, prot);
    }

    public Client(TProtocol iprot, TProtocol oprot)
    {
      iprot_ = iprot;
      oprot_ = oprot;
    }

    protected TProtocol iprot_;
    protected TProtocol oprot_;

    protected int seqid_;

    public TProtocol getInputProtocol()
    {
      return this.iprot_;
    }

    public TProtocol getOutputProtocol()
    {
      return this.oprot_;
    }

    public boolean gossip(Node sender, List<Node> neighbors) throws TException
    {
      send_gossip(sender, neighbors);
      return recv_gossip();
    }

    public void send_gossip(Node sender, List<Node> neighbors) throws TException
    {
      oprot_.writeMessageBegin(new TMessage("gossip", TMessageType.CALL, ++seqid_));
      gossip_args args = new gossip_args();
      args.setSender(sender);
      args.setNeighbors(neighbors);
      args.write(oprot_);
      oprot_.writeMessageEnd();
      oprot_.getTransport().flush();
    }

    public boolean recv_gossip() throws TException
    {
      TMessage msg = iprot_.readMessageBegin();
      if (msg.type == TMessageType.EXCEPTION) {
        TApplicationException x = TApplicationException.read(iprot_);
        iprot_.readMessageEnd();
        throw x;
      }
      if (msg.seqid != seqid_) {
        throw new TApplicationException(TApplicationException.BAD_SEQUENCE_ID, "gossip failed: out of sequence response");
      }
      gossip_result result = new gossip_result();
      result.read(iprot_);
      iprot_.readMessageEnd();
      if (result.isSetSuccess()) {
        return result.success;
      }
      throw new TApplicationException(TApplicationException.MISSING_RESULT, "gossip failed: unknown result");
    }

  }
  public static class AsyncClient extends TAsyncClient implements AsyncIface {
    public static class Factory implements TAsyncClientFactory<AsyncClient> {
      private TAsyncClientManager clientManager;
      private TProtocolFactory protocolFactory;
      public Factory(TAsyncClientManager clientManager, TProtocolFactory protocolFactory) {
        this.clientManager = clientManager;
        this.protocolFactory = protocolFactory;
      }
      public AsyncClient getAsyncClient(TNonblockingTransport transport) {
        return new AsyncClient(protocolFactory, clientManager, transport);
      }
    }

    public AsyncClient(TProtocolFactory protocolFactory, TAsyncClientManager clientManager, TNonblockingTransport transport) {
      super(protocolFactory, clientManager, transport);
    }

    public void gossip(Node sender, List<Node> neighbors, AsyncMethodCallback<gossip_call> resultHandler) throws TException {
      checkReady();
      gossip_call method_call = new gossip_call(sender, neighbors, resultHandler, this, protocolFactory, transport);
      manager.call(method_call);
    }

    public static class gossip_call extends TAsyncMethodCall {
      private Node sender;
      private List<Node> neighbors;
      public gossip_call(Node sender, List<Node> neighbors, AsyncMethodCallback<gossip_call> resultHandler, TAsyncClient client, TProtocolFactory protocolFactory, TNonblockingTransport transport) throws TException {
        super(client, protocolFactory, transport, resultHandler, false);
        this.sender = sender;
        this.neighbors = neighbors;
      }

      public void write_args(TProtocol prot) throws TException {
        prot.writeMessageBegin(new TMessage("gossip", TMessageType.CALL, 0));
        gossip_args args = new gossip_args();
        args.setSender(sender);
        args.setNeighbors(neighbors);
        args.write(prot);
        prot.writeMessageEnd();
      }

      public boolean getResult() throws TException {
        if (getState() != State.RESPONSE_READ) {
          throw new IllegalStateException("Method call not finished!");
        }
        TMemoryInputTransport memoryTransport = new TMemoryInputTransport(getFrameBuffer().array());
        TProtocol prot = client.getProtocolFactory().getProtocol(memoryTransport);
        return (new Client(prot)).recv_gossip();
      }
    }

  }

  public static class Processor implements TProcessor {
    private static final Logger LOGGER = LoggerFactory.getLogger(Processor.class.getName());
    public Processor(Iface iface)
    {
      iface_ = iface;
      processMap_.put("gossip", new gossip());
    }

    protected static interface ProcessFunction {
      public void process(int seqid, TProtocol iprot, TProtocol oprot) throws TException;
    }

    private Iface iface_;
    protected final HashMap<String,ProcessFunction> processMap_ = new HashMap<String,ProcessFunction>();

    public boolean process(TProtocol iprot, TProtocol oprot) throws TException
    {
      TMessage msg = iprot.readMessageBegin();
      ProcessFunction fn = processMap_.get(msg.name);
      if (fn == null) {
        TProtocolUtil.skip(iprot, TType.STRUCT);
        iprot.readMessageEnd();
        TApplicationException x = new TApplicationException(TApplicationException.UNKNOWN_METHOD, "Invalid method name: '"+msg.name+"'");
        oprot.writeMessageBegin(new TMessage(msg.name, TMessageType.EXCEPTION, msg.seqid));
        x.write(oprot);
        oprot.writeMessageEnd();
        oprot.getTransport().flush();
        return true;
      }
      fn.process(msg.seqid, iprot, oprot);
      return true;
    }

    private class gossip implements ProcessFunction {
      public void process(int seqid, TProtocol iprot, TProtocol oprot) throws TException
      {
        gossip_args args = new gossip_args();
        try {
          args.read(iprot);
        } catch (TProtocolException e) {
          iprot.readMessageEnd();
          TApplicationException x = new TApplicationException(TApplicationException.PROTOCOL_ERROR, e.getMessage());
          oprot.writeMessageBegin(new TMessage("gossip", TMessageType.EXCEPTION, seqid));
          x.write(oprot);
          oprot.writeMessageEnd();
          oprot.getTransport().flush();
          return;
        }
        iprot.readMessageEnd();
        gossip_result result = new gossip_result();
        result.success = iface_.gossip(args.sender, args.neighbors);
        result.setSuccessIsSet(true);
        oprot.writeMessageBegin(new TMessage("gossip", TMessageType.REPLY, seqid));
        result.write(oprot);
        oprot.writeMessageEnd();
        oprot.getTransport().flush();
      }

    }

  }

  public static class gossip_args implements TBase<gossip_args, gossip_args._Fields>, java.io.Serializable, Cloneable   {
    private static final TStruct STRUCT_DESC = new TStruct("gossip_args");

    private static final TField SENDER_FIELD_DESC = new TField("sender", TType.STRUCT, (short)1);
    private static final TField NEIGHBORS_FIELD_DESC = new TField("neighbors", TType.LIST, (short)2);

    public Node sender;
    public List<Node> neighbors;

    /** The set of fields this struct contains, along with convenience methods for finding and manipulating them. */
    public enum _Fields implements TFieldIdEnum {
      SENDER((short)1, "sender"),
      NEIGHBORS((short)2, "neighbors");

      private static final Map<String, _Fields> byName = new HashMap<String, _Fields>();

      static {
        for (_Fields field : EnumSet.allOf(_Fields.class)) {
          byName.put(field.getFieldName(), field);
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, or null if its not found.
       */
      public static _Fields findByThriftId(int fieldId) {
        switch(fieldId) {
          case 1: // SENDER
            return SENDER;
          case 2: // NEIGHBORS
            return NEIGHBORS;
          default:
            return null;
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, throwing an exception
       * if it is not found.
       */
      public static _Fields findByThriftIdOrThrow(int fieldId) {
        _Fields fields = findByThriftId(fieldId);
        if (fields == null) throw new IllegalArgumentException("Field " + fieldId + " doesn't exist!");
        return fields;
      }

      /**
       * Find the _Fields constant that matches name, or null if its not found.
       */
      public static _Fields findByName(String name) {
        return byName.get(name);
      }

      private final short _thriftId;
      private final String _fieldName;

      _Fields(short thriftId, String fieldName) {
        _thriftId = thriftId;
        _fieldName = fieldName;
      }

      public short getThriftFieldId() {
        return _thriftId;
      }

      public String getFieldName() {
        return _fieldName;
      }
    }

    // isset id assignments

    public static final Map<_Fields, FieldMetaData> metaDataMap;
    static {
      Map<_Fields, FieldMetaData> tmpMap = new EnumMap<_Fields, FieldMetaData>(_Fields.class);
      tmpMap.put(_Fields.SENDER, new FieldMetaData("sender", TFieldRequirementType.DEFAULT, 
          new StructMetaData(TType.STRUCT, Node.class)));
      tmpMap.put(_Fields.NEIGHBORS, new FieldMetaData("neighbors", TFieldRequirementType.DEFAULT, 
          new ListMetaData(TType.LIST, 
              new StructMetaData(TType.STRUCT, Node.class))));
      metaDataMap = Collections.unmodifiableMap(tmpMap);
      FieldMetaData.addStructMetaDataMap(gossip_args.class, metaDataMap);
    }

    public gossip_args() {
    }

    public gossip_args(
      Node sender,
      List<Node> neighbors)
    {
      this();
      this.sender = sender;
      this.neighbors = neighbors;
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public gossip_args(gossip_args other) {
      if (other.isSetSender()) {
        this.sender = new Node(other.sender);
      }
      if (other.isSetNeighbors()) {
        List<Node> __this__neighbors = new ArrayList<Node>();
        for (Node other_element : other.neighbors) {
          __this__neighbors.add(new Node(other_element));
        }
        this.neighbors = __this__neighbors;
      }
    }

    public gossip_args deepCopy() {
      return new gossip_args(this);
    }

    @Deprecated
    public gossip_args clone() {
      return new gossip_args(this);
    }

    public Node getSender() {
      return this.sender;
    }

    public gossip_args setSender(Node sender) {
      this.sender = sender;
      return this;
    }

    public void unsetSender() {
      this.sender = null;
    }

    /** Returns true if field sender is set (has been asigned a value) and false otherwise */
    public boolean isSetSender() {
      return this.sender != null;
    }

    public void setSenderIsSet(boolean value) {
      if (!value) {
        this.sender = null;
      }
    }

    public int getNeighborsSize() {
      return (this.neighbors == null) ? 0 : this.neighbors.size();
    }

    public java.util.Iterator<Node> getNeighborsIterator() {
      return (this.neighbors == null) ? null : this.neighbors.iterator();
    }

    public void addToNeighbors(Node elem) {
      if (this.neighbors == null) {
        this.neighbors = new ArrayList<Node>();
      }
      this.neighbors.add(elem);
    }

    public List<Node> getNeighbors() {
      return this.neighbors;
    }

    public gossip_args setNeighbors(List<Node> neighbors) {
      this.neighbors = neighbors;
      return this;
    }

    public void unsetNeighbors() {
      this.neighbors = null;
    }

    /** Returns true if field neighbors is set (has been asigned a value) and false otherwise */
    public boolean isSetNeighbors() {
      return this.neighbors != null;
    }

    public void setNeighborsIsSet(boolean value) {
      if (!value) {
        this.neighbors = null;
      }
    }

    public void setFieldValue(_Fields field, Object value) {
      switch (field) {
      case SENDER:
        if (value == null) {
          unsetSender();
        } else {
          setSender((Node)value);
        }
        break;

      case NEIGHBORS:
        if (value == null) {
          unsetNeighbors();
        } else {
          setNeighbors((List<Node>)value);
        }
        break;

      }
    }

    public void setFieldValue(int fieldID, Object value) {
      setFieldValue(_Fields.findByThriftIdOrThrow(fieldID), value);
    }

    public Object getFieldValue(_Fields field) {
      switch (field) {
      case SENDER:
        return getSender();

      case NEIGHBORS:
        return getNeighbors();

      }
      throw new IllegalStateException();
    }

    public Object getFieldValue(int fieldId) {
      return getFieldValue(_Fields.findByThriftIdOrThrow(fieldId));
    }

    /** Returns true if field corresponding to fieldID is set (has been asigned a value) and false otherwise */
    public boolean isSet(_Fields field) {
      switch (field) {
      case SENDER:
        return isSetSender();
      case NEIGHBORS:
        return isSetNeighbors();
      }
      throw new IllegalStateException();
    }

    public boolean isSet(int fieldID) {
      return isSet(_Fields.findByThriftIdOrThrow(fieldID));
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof gossip_args)
        return this.equals((gossip_args)that);
      return false;
    }

    public boolean equals(gossip_args that) {
      if (that == null)
        return false;

      boolean this_present_sender = true && this.isSetSender();
      boolean that_present_sender = true && that.isSetSender();
      if (this_present_sender || that_present_sender) {
        if (!(this_present_sender && that_present_sender))
          return false;
        if (!this.sender.equals(that.sender))
          return false;
      }

      boolean this_present_neighbors = true && this.isSetNeighbors();
      boolean that_present_neighbors = true && that.isSetNeighbors();
      if (this_present_neighbors || that_present_neighbors) {
        if (!(this_present_neighbors && that_present_neighbors))
          return false;
        if (!this.neighbors.equals(that.neighbors))
          return false;
      }

      return true;
    }

    @Override
    public int hashCode() {
      return 0;
    }

    public int compareTo(gossip_args other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;
      gossip_args typedOther = (gossip_args)other;

      lastComparison = Boolean.valueOf(isSetSender()).compareTo(typedOther.isSetSender());
      if (lastComparison != 0) {
        return lastComparison;
      }
      if (isSetSender()) {        lastComparison = TBaseHelper.compareTo(this.sender, typedOther.sender);
        if (lastComparison != 0) {
          return lastComparison;
        }
      }
      lastComparison = Boolean.valueOf(isSetNeighbors()).compareTo(typedOther.isSetNeighbors());
      if (lastComparison != 0) {
        return lastComparison;
      }
      if (isSetNeighbors()) {        lastComparison = TBaseHelper.compareTo(this.neighbors, typedOther.neighbors);
        if (lastComparison != 0) {
          return lastComparison;
        }
      }
      return 0;
    }

    public void read(TProtocol iprot) throws TException {
      TField field;
      iprot.readStructBegin();
      while (true)
      {
        field = iprot.readFieldBegin();
        if (field.type == TType.STOP) { 
          break;
        }
        switch (field.id) {
          case 1: // SENDER
            if (field.type == TType.STRUCT) {
              this.sender = new Node();
              this.sender.read(iprot);
            } else { 
              TProtocolUtil.skip(iprot, field.type);
            }
            break;
          case 2: // NEIGHBORS
            if (field.type == TType.LIST) {
              {
                TList _list0 = iprot.readListBegin();
                this.neighbors = new ArrayList<Node>(_list0.size);
                for (int _i1 = 0; _i1 < _list0.size; ++_i1)
                {
                  Node _elem2;
                  _elem2 = new Node();
                  _elem2.read(iprot);
                  this.neighbors.add(_elem2);
                }
                iprot.readListEnd();
              }
            } else { 
              TProtocolUtil.skip(iprot, field.type);
            }
            break;
          default:
            TProtocolUtil.skip(iprot, field.type);
        }
        iprot.readFieldEnd();
      }
      iprot.readStructEnd();

      // check for required fields of primitive type, which can't be checked in the validate method
      validate();
    }

    public void write(TProtocol oprot) throws TException {
      validate();

      oprot.writeStructBegin(STRUCT_DESC);
      if (this.sender != null) {
        oprot.writeFieldBegin(SENDER_FIELD_DESC);
        this.sender.write(oprot);
        oprot.writeFieldEnd();
      }
      if (this.neighbors != null) {
        oprot.writeFieldBegin(NEIGHBORS_FIELD_DESC);
        {
          oprot.writeListBegin(new TList(TType.STRUCT, this.neighbors.size()));
          for (Node _iter3 : this.neighbors)
          {
            _iter3.write(oprot);
          }
          oprot.writeListEnd();
        }
        oprot.writeFieldEnd();
      }
      oprot.writeFieldStop();
      oprot.writeStructEnd();
    }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("gossip_args(");
      boolean first = true;

      sb.append("sender:");
      if (this.sender == null) {
        sb.append("null");
      } else {
        sb.append(this.sender);
      }
      first = false;
      if (!first) sb.append(", ");
      sb.append("neighbors:");
      if (this.neighbors == null) {
        sb.append("null");
      } else {
        sb.append(this.neighbors);
      }
      first = false;
      sb.append(")");
      return sb.toString();
    }

    public void validate() throws TException {
      // check for required fields
    }

  }

  public static class gossip_result implements TBase<gossip_result, gossip_result._Fields>, java.io.Serializable, Cloneable   {
    private static final TStruct STRUCT_DESC = new TStruct("gossip_result");

    private static final TField SUCCESS_FIELD_DESC = new TField("success", TType.BOOL, (short)0);

    public boolean success;

    /** The set of fields this struct contains, along with convenience methods for finding and manipulating them. */
    public enum _Fields implements TFieldIdEnum {
      SUCCESS((short)0, "success");

      private static final Map<String, _Fields> byName = new HashMap<String, _Fields>();

      static {
        for (_Fields field : EnumSet.allOf(_Fields.class)) {
          byName.put(field.getFieldName(), field);
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, or null if its not found.
       */
      public static _Fields findByThriftId(int fieldId) {
        switch(fieldId) {
          case 0: // SUCCESS
            return SUCCESS;
          default:
            return null;
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, throwing an exception
       * if it is not found.
       */
      public static _Fields findByThriftIdOrThrow(int fieldId) {
        _Fields fields = findByThriftId(fieldId);
        if (fields == null) throw new IllegalArgumentException("Field " + fieldId + " doesn't exist!");
        return fields;
      }

      /**
       * Find the _Fields constant that matches name, or null if its not found.
       */
      public static _Fields findByName(String name) {
        return byName.get(name);
      }

      private final short _thriftId;
      private final String _fieldName;

      _Fields(short thriftId, String fieldName) {
        _thriftId = thriftId;
        _fieldName = fieldName;
      }

      public short getThriftFieldId() {
        return _thriftId;
      }

      public String getFieldName() {
        return _fieldName;
      }
    }

    // isset id assignments
    private static final int __SUCCESS_ISSET_ID = 0;
    private BitSet __isset_bit_vector = new BitSet(1);

    public static final Map<_Fields, FieldMetaData> metaDataMap;
    static {
      Map<_Fields, FieldMetaData> tmpMap = new EnumMap<_Fields, FieldMetaData>(_Fields.class);
      tmpMap.put(_Fields.SUCCESS, new FieldMetaData("success", TFieldRequirementType.DEFAULT, 
          new FieldValueMetaData(TType.BOOL)));
      metaDataMap = Collections.unmodifiableMap(tmpMap);
      FieldMetaData.addStructMetaDataMap(gossip_result.class, metaDataMap);
    }

    public gossip_result() {
    }

    public gossip_result(
      boolean success)
    {
      this();
      this.success = success;
      setSuccessIsSet(true);
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public gossip_result(gossip_result other) {
      __isset_bit_vector.clear();
      __isset_bit_vector.or(other.__isset_bit_vector);
      this.success = other.success;
    }

    public gossip_result deepCopy() {
      return new gossip_result(this);
    }

    @Deprecated
    public gossip_result clone() {
      return new gossip_result(this);
    }

    public boolean isSuccess() {
      return this.success;
    }

    public gossip_result setSuccess(boolean success) {
      this.success = success;
      setSuccessIsSet(true);
      return this;
    }

    public void unsetSuccess() {
      __isset_bit_vector.clear(__SUCCESS_ISSET_ID);
    }

    /** Returns true if field success is set (has been asigned a value) and false otherwise */
    public boolean isSetSuccess() {
      return __isset_bit_vector.get(__SUCCESS_ISSET_ID);
    }

    public void setSuccessIsSet(boolean value) {
      __isset_bit_vector.set(__SUCCESS_ISSET_ID, value);
    }

    public void setFieldValue(_Fields field, Object value) {
      switch (field) {
      case SUCCESS:
        if (value == null) {
          unsetSuccess();
        } else {
          setSuccess((Boolean)value);
        }
        break;

      }
    }

    public void setFieldValue(int fieldID, Object value) {
      setFieldValue(_Fields.findByThriftIdOrThrow(fieldID), value);
    }

    public Object getFieldValue(_Fields field) {
      switch (field) {
      case SUCCESS:
        return new Boolean(isSuccess());

      }
      throw new IllegalStateException();
    }

    public Object getFieldValue(int fieldId) {
      return getFieldValue(_Fields.findByThriftIdOrThrow(fieldId));
    }

    /** Returns true if field corresponding to fieldID is set (has been asigned a value) and false otherwise */
    public boolean isSet(_Fields field) {
      switch (field) {
      case SUCCESS:
        return isSetSuccess();
      }
      throw new IllegalStateException();
    }

    public boolean isSet(int fieldID) {
      return isSet(_Fields.findByThriftIdOrThrow(fieldID));
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof gossip_result)
        return this.equals((gossip_result)that);
      return false;
    }

    public boolean equals(gossip_result that) {
      if (that == null)
        return false;

      boolean this_present_success = true;
      boolean that_present_success = true;
      if (this_present_success || that_present_success) {
        if (!(this_present_success && that_present_success))
          return false;
        if (this.success != that.success)
          return false;
      }

      return true;
    }

    @Override
    public int hashCode() {
      return 0;
    }

    public int compareTo(gossip_result other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;
      gossip_result typedOther = (gossip_result)other;

      lastComparison = Boolean.valueOf(isSetSuccess()).compareTo(typedOther.isSetSuccess());
      if (lastComparison != 0) {
        return lastComparison;
      }
      if (isSetSuccess()) {        lastComparison = TBaseHelper.compareTo(this.success, typedOther.success);
        if (lastComparison != 0) {
          return lastComparison;
        }
      }
      return 0;
    }

    public void read(TProtocol iprot) throws TException {
      TField field;
      iprot.readStructBegin();
      while (true)
      {
        field = iprot.readFieldBegin();
        if (field.type == TType.STOP) { 
          break;
        }
        switch (field.id) {
          case 0: // SUCCESS
            if (field.type == TType.BOOL) {
              this.success = iprot.readBool();
              setSuccessIsSet(true);
            } else { 
              TProtocolUtil.skip(iprot, field.type);
            }
            break;
          default:
            TProtocolUtil.skip(iprot, field.type);
        }
        iprot.readFieldEnd();
      }
      iprot.readStructEnd();

      // check for required fields of primitive type, which can't be checked in the validate method
      validate();
    }

    public void write(TProtocol oprot) throws TException {
      oprot.writeStructBegin(STRUCT_DESC);

      if (this.isSetSuccess()) {
        oprot.writeFieldBegin(SUCCESS_FIELD_DESC);
        oprot.writeBool(this.success);
        oprot.writeFieldEnd();
      }
      oprot.writeFieldStop();
      oprot.writeStructEnd();
    }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("gossip_result(");
      boolean first = true;

      sb.append("success:");
      sb.append(this.success);
      first = false;
      sb.append(")");
      return sb.toString();
    }

    public void validate() throws TException {
      // check for required fields
    }

  }

}
